Fix a Tree codeforces 698B 并查集

Fix a Tree
Time Limit:2000MS     Memory Limit:262144KB     64bit IO Format:%I64d & %I64u

Description

A tree is an undirected connected graph without cycles.

Let's consider a rooted undirected tree with n vertices, numbered 1 through n. There are many ways to represent such a tree. One way is to create an array with n integers p1, p2, ..., pn, where pi denotes a parent of vertex i (here, for convenience a root is considered its own parent).

  For this rooted tree the array p is [2, 3, 3, 2].

Given a sequence p1, p2, ..., pn, one is able to restore a tree:

  1. There must be exactly one index r that pr = r. A vertex r is a root of the tree.
  2. For all other n - 1 vertices i, there is an edge between vertex i and vertex pi.

A sequence p1, p2, ..., pn is called valid if the described procedure generates some (any) rooted tree. For example, for n = 3 sequences(1,2,2)(2,3,1) and (2,1,3) are not valid.

You are given a sequence a1, a2, ..., an, not necessarily valid. Your task is to change the minimum number of elements, in order to get a valid sequence. Print the minimum number of changes and an example of a valid sequence after that number of changes. If there are many valid sequences achievable in the minimum number of changes, print any of them.

Input

The first line of the input contains an integer n (2 ≤ n ≤ 200 000) — the number of vertices in the tree.

The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ n).

Output

In the first line print the minimum number of elements to change, in order to get a valid sequence.

In the second line, print any valid sequence possible to get from (a1, a2, ..., an) in the minimum number of changes. If there are many such sequences, any of them will be accepted.

Sample Input

Input
4
2 3 3 4
Output
1
2 3 4 4 
Input
5
3 2 2 5 3
Output
0
3 2 2 5 3 
Input
8
2 3 5 4 1 6 6 7
Output
2
2 3 7 8 1 6 6 7

Hint

In the first sample, it's enough to change one element. In the provided output, a sequence represents a tree rooted in a vertex 4 (becausep4 = 4), which you can see on the left drawing below. One of other correct solutions would be a sequence 2 3 3 2, representing a tree rooted in vertex 3 (right drawing below). On both drawings, roots are painted red.

In the second sample, the given sequence is already valid.

 

做的时候一脸懵逼,虽然知道是并查集但是也不知道该怎么用,最终还是看了题解。。

其实想明白了也很简单,输入的数据有可能形成多颗树和环,而环又有两种,一种是单个节点形成的自环,那么这个节点肯定是一颗树的根,这棵树可能有一个至多个节点。第二种环就是多点形成的环,这种环是一定要拆开的,而且只用改一条边就能形成树,而第一种环不一定要动,所以要优先判断并修改第二种环。

大牛的题解:http://blog.csdn.net/bin_gege/article/details/51965976

#include <iostream>
#include <cstdio>
#include <cstring>
#define M 200005
using namespace std;
int a[M],f[M];
int getf(int k)
{
	return k==f[k]?k:f[k]=getf(f[k]);
}
int main()
{
	int n,t,cnt=0,root=0;
	scanf("%d",&n);
	for(int i=1;i<=n;i++)
	f[i]=i;
	for(int i=1;i<=n;i++)
	{
		scanf("%d",&a[i]);
		if(a[i]==i)//第一种环
		{
			root=i;
			cnt++;
		}
		else if(getf(i)==getf(a[i]))//第二种环
		{
			cnt++;
			a[i]=i;
		}
		f[getf(i)]=getf(a[i]);
	}
	if(!root)//如果没有第一种环,就从第二种环中拆出一个来当主根
	{
		for(int i=1;i<=n;i++)
		if(f[i]==i)
		{
			root=i;
		}
		cnt++;		
	}
	/*if(cnt==1)
	printf("%d\n",cnt);
	else*/
	printf("%d\n",cnt-1);//注意有一个主根,所以树的合并只需要cnt-1次
	//printf("%d",a[1]);
	for(int i=1;i<=n;i++)
	{
		if(i!=f[i])
		printf("%d ",a[i]);
		else
		printf("%d ",root);
	}
return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值